                    ;     
             
  processor 12f683  
  include <p12F683.inc>

   __CONFIG  3084h      ; . OSCIO, WDT ., PWRTE .. MCLR-
   errorlevel-302
 CBLOCK  20H
                       ; 
count                       
Reg_1
Reg_2
Reg_3
DLIT_REG
FLAG
PROVER_ON
PROVER_OFF
 ENDC
                                           ;   GPIO
;----------------------------------------------------------------------------------------------------
        bcf         STATUS, RP0  	       ;   0- 
        clrf        GPIO 
        clrf        CCP1CON               ;   CCP
        clrf        TMR2                      ;  TMR2 
        clrf        INTCON
        movlw   .248
        movwf  CCPR1L                    ;   %    
        
        bsf         STATUS, RP0  	        ;   1- 
        clrf        ANSEL 
        movlw   b'00111000'	            ;   WDT, ..-.,R-.
        movwf   OPTION_REG	      ;      OPTION 
        movlw   b'00110010'
        movwf   WPU
        clrf        PIE1                          ;    
        movlw   b'01100001'
        movwf   OSCCON 
        movlw   b'10001110'    	      ;    
        movwf   VRCON          	      ;   ~ 3,44  
        movlw      .249                      ;  
        movwf   PR2                         ;  
        movlw   b'11111011'    	     ;  0,1,3, 4, 5   ,
        movwf   TRISIO         	      ;   
         
        bcf	   STATUS, RP0         ;   0- 
        movlw  b'11000111'             ;  TMR1
        movwf  T1CON
        clrf        FLAG
        movlw    .4
        movwf    PROVER_ON
        movwf    PROVER_OFF
        movwf    count
       
        
MAIN 
                              ;  
       ;---------------------------------------------------------------------------------------------------
       movlw     .7                                         ;    
       movwf     CMCON0
       btfss       GPIO,  1   
       goto        p
       btfss       GPIO,  4   
       goto        p3
       goto        p1 
p
       btfss       GPIO,  4 
       goto       p4
       goto       p2 
p1                                           
       movlw   .153                           ;   37% 
       movwf   DLIT_REG      
       goto      m2
p2
        movlw   .123                           ;   50% 
        movwf   DLIT_REG      
        goto      m2
p3
       movlw    .61                              ;   75% 
       movwf    DLIT_REG      
       goto        m2   
p4
       clrf          DLIT_REG              ;   99% 
       
m2
        movlw   b'01001110'              ;    ( 
        movwf   CMCON0                 ;   COUT), .
                   ;-------------------------------------------------------------------------------------------------
m3                                        ;    
     ;======================================================================         
        bcf               PIR1, TMR1IF 
	  movlw	   .252                              ;  252,    
        movwf         TMR1L                       ;  4 a,  4- . 
        movlw	   .255                              ;  - 480 / 
        movwf         TMR1H                        
        call             DELAY_250                ;  0,25 (    )
        btfsc           PIR1, TMR1IF           ;   TMR1 ?
        goto           START                         ; ,   
        
                                                  ;       
        ;=====================================================
        btfss     CMCON0, COUT         ;     
        goto      PR_ST                           ;        
        ;------------------------------------------------------------------------------------------- 
        btfsc        FLAG, 4                     ;    ? 
        goto         m7 
m6   
        clrf           CCP1CON                 ; ,   CCP
        goto         m3
m7
        decfsz      PROVER_OFF, F
        goto        m2
        movlw    .4
        movwf    PROVER_OFF 
        goto       m6
                                                           ;   
        ;========================================================
PR_ST
        decfsz      PROVER_ON, F
        goto        m2
        movlw    .4
        movwf    PROVER_ON 
        bsf          FLAG, 4                  ;                  
                                                                      ;   
        ;============================================================
START
         movlw     .4
         movwf      PROVER_OFF
         btfsc        FLAG, 3
         goto         ON
         CALL     DELAY_250
         decfsz     count, F
         goto        START
         bsf         FLAG, 3                      ;               
         goto       m3
                                                           ;   
;======================================================================
ON 
       btfsc          GPIO, 3                     ;  ?
       goto           m8
       clrf           CCP1CON                  ; ,   CCP
       bcf            FLAG, 2
       goto          ON        
m8
      btfsc           FLAG, 2
      goto           m3
      movlw       .248
      movwf       CCPR1L               ;   %    
                                                      
        ;--------------------------------------------------------------------------------------------------
       clrf            PIR1                  ;     
       movlw      b'00011111'       ;    
       movwf      CCP1CON         ;      
       movlw      b'00011101'       ;    TMR2 
       movwf      T2CON             
        
m1
       call             DELAY_5
       call             DELAY_5
       btfss           PIR1, TMR2IF
       goto           $-1
       bcf             PIR1, TMR2IF
       decf           CCPR1L, F
       movfw       CCPR1L
       xorwf         DLIT_REG, W          
       bnz            m1 
       bsf            FLAG, 2              ;   
       goto          ON

;---------------------------------------------------------------------------------------------------------    
DELAY_5             
            movlw       .125
            movwf       Reg_1
            movlw       .7
            movwf       Reg_2
            decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            return
DELAY_250
            movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
            decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            decfsz      Reg_3,F
            goto        $-5
            nop
            nop
            return
            
            END


         